<?php

namespace App\Http\Middleware;

use Illuminate\Foundation\Http\Middleware\TrimStrings as Middleware;
use Closure;
use \Illuminate\Http\Request;
use Illuminate\Support\Facades\Cache;

class CheckToken extends Middleware
{
    /**
     * Handle an incoming request.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \Closure  $next
     * @return mixed
     */
    public function handle(Request $request, Closure $next)
    {
        $params = $request->all();
        if(isset($params['token'])){
            $cacheKey = $params['token'];
            if(Cache::has($cacheKey)){
                $num = Cache::get($cacheKey);
                if($num >= 10){
                    $json=[
                        'code'=>300,
                        'errorMessages' => 'Too many request,please wait a moment',
                        'success' =>false,
                    ];
                }else{
                    $num++;
                    Cache::add($cacheKey,$num,3);

                    return $next($request);

                }


                return response()->json($json);
            }else{
                Cache::add($cacheKey,1,3);
            }

        }

        $json=[
            'code'=>300,
            'errorMessages' => 'illegal access',
            'success' =>false,
        ];

        return response()->json($json);

    }




}
