<?php

use Illuminate\Http\Request;

/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| is assigned the "api" middleware group. Enjoy building your API!
|
*/

Route::middleware('auth:api')->get('/user', function (Request $request) {
    return $request->user();
});

Route::any('login', 'Api\LoginController@login');
Route::any('test', 'Api\TestController@aa');
Route::any('getHeaderWord', 'Api\HeaderWordController@getHeaderWord');
//文件获取
Route::any('uploadFiles/{file_name}', 'Api\FileUploadController@getFile');

Route::group(['middleware'=> ['checkLogin']],function ($route){
    $route->any('getHeaderSetting', 'Api\HeaderWordController@getHeaderSettings');
    $route->any('excelExport', 'Api\ExcelController@excelExport');
    $route->any('HeaderSettingsAdd', 'Api\HeaderWordController@add');
    $route->any('HeaderSettingsDetail', 'Api\HeaderWordController@detail');

    //文件上传统一方法
    $route->any('uploadFile', 'Api\FileUploadController@uploadFile');

    $route->any('menuAdd', 'Api\SysMenuController@add');
    $route->any('menuEdit', 'Api\SysMenuController@edit');
    $route->any('menuDel', 'Api\SysMenuController@del');
    $route->any('menuList', 'Api\SysMenuController@menuList');
    $route->any('menuMove', 'Api\SysMenuController@menuMove');

    $route->any('employeeAdd', 'Api\EmployeeController@employeeAdd');
    $route->any('employeeEdit', 'Api\EmployeeController@employeeEdit');
    $route->any('employeeDel', 'Api\EmployeeController@employeeDel');
    $route->any('employeeList', 'Api\EmployeeController@employeeList');

    $route->any('departAdd', 'Api\EmployeeController@departAdd');
    $route->any('departEdit', 'Api\EmployeeController@departEdit');
    $route->any('departDel', 'Api\EmployeeController@departDel');
    $route->any('departList', 'Api\EmployeeController@departList');

    $route->any('roleAdd', 'Api\EmployeeController@roleAdd');
    $route->any('roleEdit', 'Api\EmployeeController@roleEdit');
    $route->any('roleDel', 'Api\EmployeeController@roleDel');
    $route->any('roleList', 'Api\EmployeeController@roleList');
    $route->any('roleDetail', 'Api\EmployeeController@roleDetail');
    $route->any('roleMenu', 'Api\EmployeeController@roleMenu');

    $route->any('teamAdd', 'Api\EmployeeController@teamAdd');
    $route->any('teamEdit', 'Api\EmployeeController@teamEdit');
    $route->any('teamDel', 'Api\EmployeeController@teamDel');
    $route->any('teamList', 'Api\EmployeeController@teamList');
    $route->any('teamDetail', 'Api\EmployeeController@teamDetail');

    $route->any('employeeDepart', 'Api\EmployeeController@employeeDepart');
    $route->any('employeeTeam', 'Api\EmployeeController@employeeTeam');
    $route->any('employeeRole', 'Api\EmployeeController@employeeRole');

    //仓库档案
    $route->any('storehouseList', 'Api\StorehouseController@storehouseList');
    $route->any('storehouseDetail', 'Api\StorehouseController@storehouseDetail');
    $route->any('storehouseAdd', 'Api\StorehouseController@add');
    $route->any('storehouseEdit', 'Api\StorehouseController@edit');
    $route->any('storehouseDel', 'Api\StorehouseController@del');

    //单据状态变动
    $route->any('checkAll', 'Api\CheckController@checkAll');

    //基础类型
    $route->any('basicTypeList', 'Api\BasicTypeController@basicTypeList');
    $route->any('basicTypeEdit', 'Api\BasicTypeController@basicTypeEdit');
    $route->any('basicTypeAdd', 'Api\BasicTypeController@basicTypeAdd');
    $route->any('basicTypeDel', 'Api\BasicTypeController@basicTypeDel');

    //跟进记录
    $route->any('followUpRecordList', 'Api\FollowUpRecordController@followUpRecordList');
    $route->any('followUpRecordEdit', 'Api\FollowUpRecordController@followUpRecordEdit');
    $route->any('followUpRecordAdd', 'Api\FollowUpRecordController@followUpRecordAdd');
    $route->any('followUpRecordDetail', 'Api\FollowUpRecordController@followUpRecordDetail');
    $route->any('followUpRecordDel', 'Api\FollowUpRecordController@followUpRecordDel');

    //客户
    $route->any('customerList', 'Api\CustomerController@customerList');
    $route->any('customerEdit', 'Api\CustomerController@customerEdit');
    $route->any('customerAdd', 'Api\CustomerController@customerAdd');
    $route->any('customerDel', 'Api\CustomerController@customerDel');
    $route->any('customerDetail', 'Api\CustomerController@customerDetail');
    $route->any('customerGrabbing', 'Api\CustomerController@customerGrabbing');

    //供应商
    $route->any('supplierList', 'Api\SupplierController@customerList');
    $route->any('supplierEdit', 'Api\SupplierController@customerEdit');
    $route->any('supplierAdd', 'Api\SupplierController@customerAdd');
    $route->any('supplierDel', 'Api\SupplierController@customerDel');
    $route->any('supplierDetail', 'Api\SupplierController@customerDetail');

    //联系人
    $route->any('contactsList', 'Api\ContactsController@contactsList');
    $route->any('contactsEdit', 'Api\ContactsController@contactsEdit');
    $route->any('contactsAdd', 'Api\ContactsController@contactsAdd');
    $route->any('contactsDel', 'Api\ContactsController@contactsDel');
    $route->any('contactsDetail', 'Api\ContactsController@contactsDetail');

    //产品分类
    $route->any('productCategoryList', 'Api\ProductController@productCategoryList');
    $route->any('productCategoryEdit', 'Api\ProductController@productCategoryEdit');
    $route->any('productCategoryAdd', 'Api\ProductController@productCategoryAdd');
    $route->any('productCategoryDel', 'Api\ProductController@productCategoryDel');

    //产品名称
    $route->any('productList', 'Api\ProductController@productList');
    $route->any('productEdit', 'Api\ProductController@productEdit');
    $route->any('productAdd', 'Api\ProductController@productAdd');
    $route->any('productDel', 'Api\ProductController@productDel');
    $route->any('productDetail', 'Api\ProductController@productDetail');

    //采购单
    $route->any('purchaseOrderList', 'Api\PurchaseOrderController@purchaseOrderList');
    $route->any('purchaseOrderEdit', 'Api\PurchaseOrderController@purchaseOrderEdit');
    $route->any('purchaseOrderDetail', 'Api\PurchaseOrderController@purchaseOrderDetail');
    $route->any('purchaseOrderAdd', 'Api\PurchaseOrderController@purchaseOrderAdd');
    $route->any('purchaseOrderDel', 'Api\PurchaseOrderController@purchaseOrderDel');

    //发货单
    $route->any('invoiceOrderList', 'Api\InvoiceOrderController@invoiceOrderList');
    $route->any('invoiceOrderEdit', 'Api\InvoiceOrderController@invoiceOrderEdit');
    $route->any('invoiceOrderDetail', 'Api\InvoiceOrderController@invoiceOrderDetail');
    $route->any('invoiceOrderAdd', 'Api\InvoiceOrderController@invoiceOrderAdd');
    $route->any('invoiceOrderDel', 'Api\InvoiceOrderController@invoiceOrderDel');

    //收货单
    $route->any('takeOrderList', 'Api\TakeOrderController@takeOrderList');
    $route->any('takeOrderEdit', 'Api\TakeOrderController@takeOrderEdit');
    $route->any('takeOrderDetail', 'Api\TakeOrderController@takeOrderDetail');
    $route->any('takeOrderAdd', 'Api\TakeOrderController@takeOrderAdd');
    $route->any('takeOrderDel', 'Api\TakeOrderController@takeOrderDel');

    //合同
    $route->any('salesOrderGet', 'Api\SalesOrderController@salesOrderGet');
    $route->any('salesOrderList', 'Api\SalesOrderController@salesOrderList');
    $route->any('salesOrderEdit', 'Api\SalesOrderController@salesOrderEdit');
    $route->any('salesOrderDetail', 'Api\SalesOrderController@salesOrderDetail');
    $route->any('salesOrderAdd', 'Api\SalesOrderController@salesOrderAdd');
    $route->any('salesOrderDel', 'Api\SalesOrderController@salesOrderDel');
    //派单销售
    $route->any('salesOrderDispatchSale', 'Api\SalesOrderController@salesOrderDispatchSale');
    //派单总部或分社
    $route->any('salesOrderDispatchCompany', 'Api\SalesOrderController@salesOrderDispatchCompany');

    //施工单
    $route->any('constructionGet', 'Api\ConstructionController@constructionGet');
    $route->any('constructionList', 'Api\ConstructionController@constructionList');
    $route->any('constructionEdit', 'Api\ConstructionController@constructionEdit');
    $route->any('constructionDetail', 'Api\ConstructionController@constructionDetail');
    $route->any('constructionAdd', 'Api\ConstructionController@constructionAdd');
    $route->any('constructionDel', 'Api\ConstructionController@constructionDel');

    //退换货
    $route->any('ReturnExchangeOrderList', 'Api\ReturnExchangeOrderController@ReturnExchangeOrderList');
    $route->any('ReturnExchangeOrderEdit', 'Api\ReturnExchangeOrderController@ReturnExchangeOrderEdit');
    $route->any('ReturnExchangeOrderDetail', 'Api\ReturnExchangeOrderController@ReturnExchangeOrderDetail');
    $route->any('ReturnExchangeOrderAdd', 'Api\ReturnExchangeOrderController@ReturnExchangeOrderAdd');
    $route->any('ReturnExchangeOrderDel', 'Api\ReturnExchangeOrderController@ReturnExchangeOrderDel');

    //活动包
    $route->any('sportsBagOrderList', 'Api\SportsBagController@orderList');
    $route->any('sportsBagEdit', 'Api\SportsBagController@edit');
    $route->any('sportsBagDetail', 'Api\SportsBagController@detail');
    $route->any('sportsBagAdd', 'Api\SportsBagController@add');
    $route->any('sportsBagDel', 'Api\SportsBagController@del');

    //活动价列表
    $route->any('productActivityList', 'Api\ProductActivityController@productList');
    $route->any('productActivityEdit', 'Api\ProductActivityController@productEdit');
    $route->any('productActivityAdd', 'Api\ProductActivityController@productAdd');
    $route->any('productActivityDel', 'Api\ProductActivityController@productDel');
    $route->any('productActivityDetail', 'Api\ProductActivityController@productDetail');

    //金额记账
    $route->any('BookingList', 'Api\BookingListController@customerList');
    $route->any('BookingAdd', 'Api\BookingListController@customerAdd');
    $route->any('BookingEdit', 'Api\BookingListController@customerEdit');
    $route->any('BookingDel', 'Api\BookingListController@customerDel');
    $route->any('BookingDetail', 'Api\BookingListController@customerDetail');
    $route->any('BookingConfirm', 'Api\BookingListController@customerConfirm');

    //现存量
    $route->any('productInventoryList', 'Api\ProductInventoryController@productInventoryList');
    //库存台账
    $route->any('productInventoryStockList', 'Api\ProductInventoryController@productInventoryStockList');
    //收发存汇总
    $route->any('productInAndOutList', 'Api\ProductInventoryController@productInAndOutList');
    //设置列表
    $route->any('productInventorySetList', 'Api\ProductInventoryController@productInventorySetList');
    //设置开关
    $route->any('productInventorySet', 'Api\ProductInventoryController@productInventorySet');
    //可见范围
    $route->any('seeRange', 'Api\RangeController@seeRange');
});
